

/* stattree.h */


/*------------------------------------------------------------------------
 * Solitaire field statistics: Tree
 *------------------------------------------------------------------------
 */


/*
 * StatGame[Stones]->StatStne[SymType]->StatSymm[All|Nrm]->StatTree
 *
 * Patterns   : How many patterns exist at all.
 * MovesPat[n]: How many patterns exist with n possible moves.
 * MovesSum   : How many moves are existing at all.
 * WaysEnd    : How many game ways end at this pattern type (n == 0).
 *
 * The Tree type is given as a parameter for calculation.
 * All: Patterns is incremented by the SymType.
 *      n is taken from FIELDSTT.MovesAll
 *      MovesPat is incremented by SymType.
 *      Counter for WaysEnd is FIELDSTT.CounterAll
 * Nrm: Patterns is incremented by one.
 *      n is taken from FIELDSTT.MovesNrm
 *      MovesPat is incremented by one.
 *      Counter for WaysEnd is FIELDSTT.CounterNrm
 */


/*----------------------------------------------------------------------*/

#ifndef STATTREE_H
#define STATTREE_H

/*----------------------------------------------------------------------*/

#include "mytypes.h"
#include "field.h"
#include "stattabs.h"

/*----------------------------------------------------------------------*/


typedef struct s_STATTREE *tpsSTATTREE;
typedef tpsSTATTREE       *tppsSTATTREE;

/*---------------------------------------------*/

tpsSTATTREE psStatTreeCreate   (tVOID);
tpsSTATTREE psStatTreeDestroy  (tpsSTATTREE psTree);
tpsSTATTREE psStatTreeMemUsage (tpsSTATTREE psTree, tpCOUNT pcnSizeof, tpCOUNT pcnBlocks);

tVOID       vStatTreeAddField  (tpsSTATTREE psTree, tpsFIELDSTT psStt, tBOOL bTreeAll);
tVOID       vStatTreeAddObject (tpsSTATTREE psTree, tpsSTATTREE psAdd);
tVOID       vStatTreeCalcWhole (tpsSTATTREE psTree);
tBOOL       bStatTreeIsEmpty   (tpsSTATTREE psTree);
tCOUNT      cnStatTreeMaxMoves (tpsSTATTREE psTree);

tVOID       vStatTreeTabSet    (tpsSTATTREE psTree, tpsSTATTABS psTabs, tPSZc pzContent);


/*----------------------------------------------------------------------*/

#endif
